#include "TObject.h"
#include <vector>
#include <iostream>

#ifndef Test_hh
#define Test_hh

class MyVec : public std::vector<double> 
{
  public: 
    MyVec() : std::vector<double>() { std::cout << "Vec construct: " << std::endl; PrintLoc(); }
                                      
                                      
    MyVec(size_t i) : std::vector<double>(i) {} 
    MyVec(size_t i, double val) : std::vector<double>(i, val) {} 
    ~MyVec() { std::cout << "In Vec destructor" << std::endl; }
    void PrintLoc() {  std::cout << "  memory ptr:" << &this->_M_impl._M_start  << std::endl; 
                       std::cout << "  memory loc:" << this->_M_impl._M_start  << std::endl;} 
};

class Master: public TObject
{
  public:
    Master() { std::cout << "Building Master" << std::endl; }
    ~Master() { std::cout << "Destroying Master" << std::endl; }

    MyVec    fvector;

  ClassDef(Master, 1);
};
#endif /* Test_hh */
