#include "Test.hh"
#include "TClonesArray.h"
#include "TClass.h"
#include <iostream>
using namespace std;

int main() {

  TClonesArray temp(Master::Class(), 100);  
  
  cout << "First master" << endl;
  Master* amaster = new(temp[0]) Master();

  amaster->fvector.resize(100);
  cout << amaster->fvector.capacity() << endl;
  cout << &amaster->fvector[0] << endl;
  amaster->fvector.PrintLoc();

  temp.Clear("C");

  cout << endl;
  cout << "Second master" << endl;
  amaster = new(temp[0]) Master();

  cout << "The memory is gone!" << std::endl;
  cout << amaster->fvector.capacity() << endl;
  cout << &amaster->fvector[0] << endl;
  amaster->fvector.PrintLoc();

  amaster->fvector.resize(100);

  temp.Delete();

  cout << endl;
  cout << "Third master" << endl;
  amaster = new(temp[0]) Master();

  cout << amaster->fvector.capacity() << endl;
  cout << &amaster->fvector[0] << endl;
  amaster->fvector.PrintLoc();

  return 0;
}
